Bug 858729 - Review Request: libldm - A library and tool for managing Windows dynamic disks
Review Request: libldm - A library and tool for managing Windows dynamic disks
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Richard W.M. Jones
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-09-19 10:03 EDT by Matthew Booth
Modified: 2012-12-20 10:33 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-12-20 10:33:17 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
rjones: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Matthew Booth 2012-09-19 10:03:52 EDT
Spec URL: http://people.redhat.com/mbooth/libldm/libldm.spec
SRPM URL: http://people.redhat.com/mbooth/libldm/libldm-0.2-1.fc17.src.rpm

Description:
libldm is a library for managing Microsoft Windows dynamic disks, which use
Microsoft's LDM metadata. It can inspect them, and also create and remove
device-mapper block devices which can be mounted. It includes ldmtool, which
exposes this functionality as a command-line tool.

Fedora Account System Username: mdbooth
Comment 1 Richard W.M. Jones 2012-09-19 10:51:37 EDT
The fedora-review program has the following to say.  There are
a few cleanups necessary in there ...


Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== C/C++ ====
[x]: MUST Header files in -devel subpackage, if present.
[x]: MUST Package does not contain any libtool archives (.la)
[ ]: MUST Package does not contain kernel modules.
[ ]: MUST Package contains no static executables.
[x]: MUST Rpath absent or only used for internal libs.
[x]: MUST Development (unversioned) .so files in -devel subpackage, if
     present.


==== Generic ====
[x]: EXTRA Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: EXTRA Spec file according to URL is the same as in SRPM.
[ ]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[ ]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[ ]: MUST Package contains no bundled libraries.
[ ]: MUST Changelog in prescribed format.
[ ]: MUST Sources contain only permissible code or content.
[x]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: Note: defattr macros not found. They would be needed for EPEL5
[ ]: MUST Macros in Summary, %description expandable at SRPM build time.
[ ]: MUST Package contains desktop file if it is a GUI application.
[ ]: MUST Development files must be in a -devel package
[ ]: MUST Package requires other packages for directories it uses.
[ ]: MUST Package uses nothing in %doc for runtime.
[ ]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Fully versioned dependency in subpackages, if present.
[ ]: MUST Package complies to the Packaging Guidelines
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
[ ]: MUST Large documentation files are in a -doc subpackage, if required.
[ ]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[ ]: MUST License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "LGPL (v3 or later)", "GPL (v2 or later)", "GPL (v3 or later)" For
     detailed output of licensecheck see file:
     /tmp/858729-libldm/licensecheck.txt
[ ]: MUST License file installed when any subpackage combination is installed.
[ ]: MUST Package consistently uses macro is (instead of hard-coded directory
     names).
[ ]: MUST If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: MUST Package is named using only allowed ascii characters.
[ ]: MUST Package is named according to the Package Naming Guidelines.
[ ]: MUST Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[ ]: MUST Package obeys FHS, except libexecdir and /usr/target.
[ ]: MUST If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[ ]: MUST Package must own all directories that it creates.
[ ]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[ ]: MUST Package is not relocatable.
[!]: MUST Package requires pkgconfig, if .pc files are present. (EPEL5)
     Note: Only applicable for EL-5
[ ]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
[ ]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[ ]: MUST Package contains systemd file(s) if in need.
[x]: MUST File names are valid UTF-8.
[ ]: MUST Useful -debuginfo package or justification otherwise.
[x]: SHOULD Reviewer should test that the package builds in mock.
[x]: SHOULD Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[x]: SHOULD Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean would be needed if support for EPEL5 is required
[ ]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[!]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[ ]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[ ]: SHOULD Package functions as described.
[ ]: SHOULD Latest version is packaged.
[ ]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD The placement of pkgconfig(.pc) files are correct.
[x]: SHOULD SourceX tarball generation or download is documented.
[x]: SHOULD SourceX / PatchY prefixed with %{name}.
[x]: SHOULD SourceX is a working URL.
[ ]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[ ]: SHOULD %check is present and all tests pass.
[ ]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.

Issues:
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
See: None
[!]: MUST Package requires pkgconfig, if .pc files are present. (EPEL5)
     Note: Only applicable for EL-5
See: http://fedoraproject.org/wiki/EPEL/GuidelinesAndPolicies#EL5

Rpmlint
-------
Checking: libldm-devel-0.2-1.fc17.x86_64.rpm
          libldm-debuginfo-0.2-1.fc17.x86_64.rpm
          libldm-0.2-1.fc17.src.rpm
          libldm-0.2-1.fc17.x86_64.rpm
libldm.src: W: spelling-error %description -l en_US metadata -> meta data, meta-data, metatarsal
libldm.src: W: spelling-error %description -l en_US ldmtool -> toadstool
libldm.x86_64: W: spelling-error %description -l en_US metadata -> meta data, meta-data, metatarsal
libldm.x86_64: E: library-without-ldconfig-postin /usr/lib64/libldm-1.0.so.0.0.0
libldm.x86_64: E: library-without-ldconfig-postun /usr/lib64/libldm-1.0.so.0.0.0
4 packages and 0 specfiles checked; 2 errors, 3 warnings.


Rpmlint (installed packages)
----------------------------
# rpmlint libldm-debuginfo
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'

Requires
--------
libldm-devel-0.2-1.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /usr/bin/pkg-config
    libldm(x86-64) = 0.2-1.fc17
    libldm-1.0.so.0()(64bit)

libldm-debuginfo-0.2-1.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    

libldm-0.2-1.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    
    libc.so.6()(64bit)
    libdevmapper.so.1.02()(64bit)
    libdevmapper.so.1.02(Base)(64bit)
    libgio-2.0.so.0()(64bit)
    libglib-2.0.so.0()(64bit)
    libgobject-2.0.so.0()(64bit)
    libjson-glib-1.0.so.0()(64bit)
    libldm-1.0.so.0()(64bit)
    libpthread.so.0()(64bit)
    libreadline.so.6()(64bit)
    libuuid.so.1()(64bit)
    libuuid.so.1(UUID_1.0)(64bit)
    libz.so.1()(64bit)
    rtld(GNU_HASH)

Provides
--------
libldm-devel-0.2-1.fc17.x86_64.rpm:
    
    libldm-devel = 0.2-1.fc17
    libldm-devel(x86-64) = 0.2-1.fc17
    pkgconfig(ldm-1.0) = 0.2

libldm-debuginfo-0.2-1.fc17.x86_64.rpm:
    
    libldm-debuginfo = 0.2-1.fc17
    libldm-debuginfo(x86-64) = 0.2-1.fc17

libldm-0.2-1.fc17.x86_64.rpm:
    
    libldm = 0.2-1.fc17
    libldm(x86-64) = 0.2-1.fc17
    libldm-1.0.so.0()(64bit)

MD5-sum check
-------------
https://github.com/mdbooth/libldm/downloads/libldm-0.2.tar.gz :
  CHECKSUM(SHA256) this package     : 872801d72dd72d2a2cd6a05f8173e8eb1ed4545df39624015a0618a403a0f947
  CHECKSUM(SHA256) upstream package : 872801d72dd72d2a2cd6a05f8173e8eb1ed4545df39624015a0618a403a0f947


Generated by fedora-review 0.2.2 (9f8c0e5) last change: 2012-08-09
Command line :/bin/fedora-review -b 858729
External plugins:
Comment 2 Matthew Booth 2012-09-19 11:36:33 EDT
Thanks, Rich.


[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
FIXED

[!]: MUST Package requires pkgconfig, if .pc files are present. (EPEL5)
     Note: Only applicable for EL-5
N/A

[!]: SHOULD Dist tag is present.
I think the tool is getting confused by extra-release. Think this is bogus.

libldm.x86_64: E: library-without-ldconfig-postin /usr/lib64/libldm-1.0.so.0.0.0
libldm.x86_64: E: library-without-ldconfig-postun /usr/lib64/libldm-1.0.so.0.0.0
FIXED. Interestingly, my rpmlint (on F17) didn't pick this up.

Also, I've defined gtk-doc and the man page as %doc.

New spec: http://people.redhat.com/mbooth/libldm/libldm.spec
New SRPM: http://people.redhat.com/mbooth/libldm/libldm-0.2-2.fc17.src.rpm
Comment 3 Richard W.M. Jones 2012-09-19 11:54:37 EDT
(In reply to comment #2)
> [...] and the man page as %doc.

I'm pretty sure that the man page ought not to be %doc.
Don't you have any README file or license you can put
into %doc?
Comment 4 Richard W.M. Jones 2012-09-19 12:06:57 EDT
See '!' below.

Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== C/C++ ====
[x]: MUST Header files in -devel subpackage, if present.
[x]: MUST Package does not contain any libtool archives (.la)
[-]: MUST Package does not contain kernel modules.
[-]: MUST Package contains no static executables.
[x]: MUST Rpath absent or only used for internal libs.
[x]: MUST Development (unversioned) .so files in -devel subpackage, if
     present.


==== Generic ====
[x]: EXTRA Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: EXTRA Spec file according to URL is the same as in SRPM.
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[x]: MUST Sources contain only permissible code or content.
[x]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: Note: defattr macros not found. They would be needed for EPEL5
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[-]: MUST Package contains desktop file if it is a GUI application.
[x]: MUST Development files must be in a -devel package
[-]: MUST Package requires other packages for directories it uses.
[-]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Fully versioned dependency in subpackages, if present.
[x]: MUST Package complies to the Packaging Guidelines
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[x]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf would be needed if support for EPEL5 is required
[-]: MUST Large documentation files are in a -doc subpackage, if required.
[-]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[!]: MUST License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "LGPL (v3 or later)", "GPL (v2 or later)", "GPL (v3 or later)" For
     detailed output of licensecheck see file:
     /tmp/858729-libldm/licensecheck.txt

The license field in the spec file is:
License:        GPLv2+ and LGPLv2+

The licensing of the package seems a bit confused.  It seems like
it is intended to be LGPLv3+ for the library and GPLv3+ for the tool.
(There is a GPLv2+ file, but that is part of libtool so I think
we can ignore it).  I think the upstream package should also include
COPYING and COPYING.LIB from the applicable version of the GPL/LGPL,
and this should be included in %doc.

[-]: MUST License file installed when any subpackage combination is installed.
[x]: MUST Package consistently uses macro is (instead of hard-coded directory
     names).
[!]: MUST If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: MUST Package is named using only allowed ascii characters.
[x]: MUST Package is named according to the Package Naming Guidelines.
[-]: MUST Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[-]: MUST If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[-]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Package is not relocatable.
[-]: MUST Package requires pkgconfig, if .pc files are present. (EPEL5)
     Note: Only applicable for EL-5
[x]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: MUST Package contains systemd file(s) if in need.
[x]: MUST File names are valid UTF-8.
[x]: MUST Useful -debuginfo package or justification otherwise.
[x]: SHOULD Reviewer should test that the package builds in mock.
[x]: SHOULD Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[x]: SHOULD Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean would be needed if support for EPEL5 is required
[!]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[-]: SHOULD Package functions as described.
[-]: SHOULD Latest version is packaged.
[-]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD The placement of pkgconfig(.pc) files are correct.
[-]: SHOULD Scriptlets must be sane, if used.
[x]: SHOULD SourceX tarball generation or download is documented.
[x]: SHOULD SourceX / PatchY prefixed with %{name}.
[x]: SHOULD SourceX is a working URL.
[-]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[-]: SHOULD %check is present and all tests pass.
[-]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.
Comment 5 Matthew Booth 2012-09-20 05:49:41 EDT
Let's have another go:

New spec: http://people.redhat.com/mbooth/libldm/libldm.spec
New SRPM: http://people.redhat.com/mbooth/libldm/libldm-0.2.1-1.fc17.src.rpm

%doc is fixed. License is updated. I had included the license text upstream, but had forgotten to add it to EXTRA_DIST, so it wasn't in the tarball. I've respun the tarball to include it, hence the minor version bump.

Matt
Comment 6 Richard W.M. Jones 2012-09-20 11:46:35 EDT
License field is fixed and %doc includes the license files.

It looks like Matthew has fixed all the issues raised in
the review (comment 4), therefore this package is approved.
Comment 7 Matthew Booth 2012-09-20 12:04:06 EDT
New Package SCM Request
=======================
Package Name: libldm
Short Description: A library and tool to manage Windows dynamic disks
Owners: mdbooth
Branches: f17 f18
InitialCC: mdbooth
Comment 8 Gwyn Ciesla 2012-09-20 12:07:49 EDT
Git done (by process-git-requests).
Comment 9 Fedora Update System 2012-09-24 11:43:46 EDT
libldm-0.2.3-1.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/libldm-0.2.3-1.fc17
Comment 10 Fedora Update System 2012-09-25 00:23:46 EDT
libldm-0.2.3-1.fc17 has been pushed to the Fedora 17 testing repository.
Comment 11 Fedora Update System 2012-12-20 10:33:22 EST
libldm-0.2.3-1.fc17 has been pushed to the Fedora 17 stable repository.

Note You need to log in before you can comment on or make changes to this bug.